package com.zulutrade.sample.trading.client.trading;


/**
 * Utility class that converts 
 * trading requests to the corresponding rest api calls
 * to ZuluTrade
 *
 * @author ZuluTrade
 */
public interface ZuluTradingRequestGenerator {	
	String getOpenMarketRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId);		
	String getCloseMarketRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId);
	String getOpenOrderRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId);
	String getCancelOrderRequest(String currencyName, Double lots, Boolean buy, String uniqueId);
	String getUpdateLimitRequest(String currencyName, Boolean isBuy, Double lots, String uniqueId, Double limitValue);
	String getUpdateStopRequest(String currencyName, Boolean isBuy, Double lots, String uniqueId, Double stopValue);
	String getUpdateTrailingStopRequest(String currencyName, Boolean isBuy, Double lots, String uniqueId, Integer trailingStopValue);
	String getUpdateTrailingStopConditionRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Integer trailingStopValue,	Integer tralingStopConditionPips);
	String getUpdateEntryRateRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Double entryRate);
	String getGetOpenTradesRequest();
	String getTradingConfigurationRequest();
	String getProviderStatisticsRequest();
	String getHistoryRequest(String startDate, String endDate);
}
